Open a Hug
A phase’s agent opens a Hug: the HugSpec fields (title, prompt, context,
requested_inputs, channels, expires_in_min, reminders, ui), checked with the
SDK’s schema. A retry with the same request_id returns the same Hug. The run’s event
stream gets hug.opened (in standalone mode with the spec and files_dir, where the CLI
copies a file it is given).
No credential is needed from this machine. From another host, send Authorization: Bearer with a dispatch token CliqHub signed for this daemon or a cliq_tok_… personal token of a user in the daemon’s realm; this only works once the daemon is connected to CliqHub. See Authentication.
curl --request POST \
--url http://127.0.0.1:4900/v1/hugs/open \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"run_id": "run-abc",
"phase": "approve",
"iteration": 0,
"request_id": "approve#0#ask0",
"title": "Review: approve",
"prompt": "Please review the plan.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [
{
"value": "approve"
},
{
"value": "reject"
}
]
}
],
"channels": [
"security"
],
"expires_in_min": 30
}
'import requests
url = "http://127.0.0.1:4900/v1/hugs/open"
payload = {
"run_id": "run-abc",
"phase": "approve",
"iteration": 0,
"request_id": "approve#0#ask0",
"title": "Review: approve",
"prompt": "Please review the plan.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [{ "value": "approve" }, { "value": "reject" }]
}
],
"channels": ["security"],
"expires_in_min": 30
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
run_id: 'run-abc',
phase: 'approve',
iteration: 0,
request_id: 'approve#0#ask0',
title: 'Review: approve',
prompt: 'Please review the plan.',
requested_inputs: [
{
name: 'decision',
type: 'enum',
choices: [{value: 'approve'}, {value: 'reject'}]
}
],
channels: ['security'],
expires_in_min: 30
})
};
fetch('http://127.0.0.1:4900/v1/hugs/open', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_PORT => "4900",
CURLOPT_URL => "http://127.0.0.1:4900/v1/hugs/open",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'run_id' => 'run-abc',
'phase' => 'approve',
'iteration' => 0,
'request_id' => 'approve#0#ask0',
'title' => 'Review: approve',
'prompt' => 'Please review the plan.',
'requested_inputs' => [
[
'name' => 'decision',
'type' => 'enum',
'choices' => [
[
'value' => 'approve'
],
[
'value' => 'reject'
]
]
]
],
'channels' => [
'security'
],
'expires_in_min' => 30
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "http://127.0.0.1:4900/v1/hugs/open"
payload := strings.NewReader("{\n \"run_id\": \"run-abc\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"request_id\": \"approve#0#ask0\",\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the plan.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("http://127.0.0.1:4900/v1/hugs/open")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"run_id\": \"run-abc\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"request_id\": \"approve#0#ask0\",\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the plan.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n}")
.asString();require 'uri'
require 'net/http'
url = URI("http://127.0.0.1:4900/v1/hugs/open")
http = Net::HTTP.new(url.host, url.port)
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"run_id\": \"run-abc\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"request_id\": \"approve#0#ask0\",\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the plan.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n}"
response = http.request(request)
puts response.read_bodyAuthorizations
Not needed from the same machine. From another host: a dispatch JWT CliqHub signed for this daemon, or a cliq_tok_… personal token whose user is in the daemon's realm.
Body
Run whose phase opens the Hug
1Phase that opens it
1HugSpec.title
HugSpec.prompt
HugSpec.requested_inputs
Phase iteration (CLIQ_PHASE_ITERATION)
0 <= x <= 9007199254740991Retry key: a retried open returns the same Hug
1 - 200Initial requester state (returned on resume)
HugSpec.context
HugSpec.channels
HugSpec.expires_in_min
HugSpec.reminders
HugSpec.ui
curl --request POST \
--url http://127.0.0.1:4900/v1/hugs/open \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"run_id": "run-abc",
"phase": "approve",
"iteration": 0,
"request_id": "approve#0#ask0",
"title": "Review: approve",
"prompt": "Please review the plan.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [
{
"value": "approve"
},
{
"value": "reject"
}
]
}
],
"channels": [
"security"
],
"expires_in_min": 30
}
'import requests
url = "http://127.0.0.1:4900/v1/hugs/open"
payload = {
"run_id": "run-abc",
"phase": "approve",
"iteration": 0,
"request_id": "approve#0#ask0",
"title": "Review: approve",
"prompt": "Please review the plan.",
"requested_inputs": [
{
"name": "decision",
"type": "enum",
"choices": [{ "value": "approve" }, { "value": "reject" }]
}
],
"channels": ["security"],
"expires_in_min": 30
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
run_id: 'run-abc',
phase: 'approve',
iteration: 0,
request_id: 'approve#0#ask0',
title: 'Review: approve',
prompt: 'Please review the plan.',
requested_inputs: [
{
name: 'decision',
type: 'enum',
choices: [{value: 'approve'}, {value: 'reject'}]
}
],
channels: ['security'],
expires_in_min: 30
})
};
fetch('http://127.0.0.1:4900/v1/hugs/open', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_PORT => "4900",
CURLOPT_URL => "http://127.0.0.1:4900/v1/hugs/open",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'run_id' => 'run-abc',
'phase' => 'approve',
'iteration' => 0,
'request_id' => 'approve#0#ask0',
'title' => 'Review: approve',
'prompt' => 'Please review the plan.',
'requested_inputs' => [
[
'name' => 'decision',
'type' => 'enum',
'choices' => [
[
'value' => 'approve'
],
[
'value' => 'reject'
]
]
]
],
'channels' => [
'security'
],
'expires_in_min' => 30
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "http://127.0.0.1:4900/v1/hugs/open"
payload := strings.NewReader("{\n \"run_id\": \"run-abc\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"request_id\": \"approve#0#ask0\",\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the plan.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("http://127.0.0.1:4900/v1/hugs/open")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"run_id\": \"run-abc\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"request_id\": \"approve#0#ask0\",\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the plan.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n}")
.asString();require 'uri'
require 'net/http'
url = URI("http://127.0.0.1:4900/v1/hugs/open")
http = Net::HTTP.new(url.host, url.port)
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"run_id\": \"run-abc\",\n \"phase\": \"approve\",\n \"iteration\": 0,\n \"request_id\": \"approve#0#ask0\",\n \"title\": \"Review: approve\",\n \"prompt\": \"Please review the plan.\",\n \"requested_inputs\": [\n {\n \"name\": \"decision\",\n \"type\": \"enum\",\n \"choices\": [\n {\n \"value\": \"approve\"\n },\n {\n \"value\": \"reject\"\n }\n ]\n }\n ],\n \"channels\": [\n \"security\"\n ],\n \"expires_in_min\": 30\n}"
response = http.request(request)
puts response.read_body